<template src="./template.html"></template>

<script lang="ts">
import _, { isBuffer } from "lodash";
import { Component, Prop, Vue, Watch } from "nuxt-property-decorator";
import { apiErrorHandler } from "~/utils/apiHanlers";
import { getTimeZone, getUnixFrom, getUnixTo } from "~/utils/timeZone";
var momentz = require("moment-timezone");
var moment = require("moment");
@Component({
  components: {
    EmptyData: () => import("@/components/Utils/EmptyData/index.vue"),
  },
})
export default class ReportByUTMComponent extends Vue {
  @Prop()
  tab!: number;
  config = {
    page: 1,
    limit: 25,
    search: "",

    utmCampaign: "",
    utmMedium: "",
  };
  loadingTable = false;
  dateStartPicker = false;
  dateEndPicker = false;
  dateStart = momentz().startOf("month").format("YYYY-MM-DD");
  dateEnd = moment().endOf("day").format("YYYY-MM-DD");
  listData: any = [];
  fav = true;
  menu = false;
  message = false;
  hints = true;
  selectedAll = [];
  utmCampaign = "";
  utmMedium = "";

  get dateArr() {
    return this.$store.state.setting?.dateArr || [];
  }

  set dateArr(value: string[]) {
    this.$store.commit("setting/setDateArr", value);
  }

  get dateRangeText() {
    return this.dateArr.join("~");
  }

  checkbox = {
    showAll: true,
    utmCampaign: true,
    utmSource: true,
    utmMedium: true,
    umtContent: true,
    conversionRate: true,
    view: true,
    addToCart: true,
    checkout: true,
    purchase: true,
    revenue: true,
    goCheckout: true,
  };

  get timeActive() {
    return this.$store.state.setting.timeActive;
  }

  set timeActive(value: string) {
    this.$store.commit("setting/setTimeActive", value);
  }
  get timezone() {
    return this.$store.state.setting.timezone;
  }

  get from() {
    return this.$store.state.setting.from;
  }

  get to() {
    return this.$store.state.setting.to;
  }

  get siteInfo() {
    return this.$store.state.setting.siteInfo;
  }

  disabledButtonDate = false;

  async onFilterByTime(time: string) {
    this.disabledButtonDate = true;
    this.$store.commit("setting/setFilterByTime", { time });
    await this.onGetListStatsUtm();
    this.disabledButtonDate = false;
  }

  mounted() {
    // this.onGetListStatsUtmFilter();
    this.onFilterByTime("Today");
  }
  clearFilter() {
    this.config.utmCampaign = "";
    this.config.utmMedium = "";
    // this.dateArr = [
    //   moment().subtract(7, "days").format("YYYY-MM-DD"),
    //   moment().format("YYYY-MM-DD"),
    // ];
    this.onGetListStatsUtm();
  }
  async onGetListStatsUtm() {
    try {
      this.loadingTable = true;
      const response = await this.$api.stats.statsAnalyticsUtm({
        ...this.config,
        from:
          this.from ||
          getUnixFrom(this.siteInfo.timezone, this.dateRangeText.split("~")[0]),
        to:
          this.to ||
          getUnixTo(this.siteInfo.timezone, this.dateRangeText.split("~")[1]),
        timezone: this.timezone,
      });
      if (response?.data) {
        this.listData = response.data;
        let conversionRate = 0;
        let viewContent = 0;
        let addToCart = 0;
        let initiateCheckout = 0;
        let purchase = 0;
        let revenue = 0;
        let view = 0;
        let checkout = 0;
        let goCheckout = 0;
        for (let item of this.listData) {
          conversionRate += item.conversionRate;
          viewContent += item.viewContent;
          addToCart += item.addToCart;
          initiateCheckout += item.initiateCheckout;
          purchase += item.purchase;
          revenue += item.revenue;
          view += item.view;
          checkout += item.checkout;
          goCheckout += item.goCheckout;
        }
        conversionRate = conversionRate / response.data.length;
        this.listData.push({
          conversionRate,
          viewContent,
          addToCart,
          initiateCheckout,
          purchase,
          revenue,
          view,
          checkout,
          goCheckout,
        });
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingTable = false;
    }
  }

  async onGetListStatsUtmFilter() {
    this.$store.commit("setting/setTime", {
      dateStart: this.dateRangeText.split("~")[0],
      dateEnd: this.dateRangeText.split("~")[1],
    });
    this.onGetListStatsUtm();
    this.timeActive = "";
  }

  get dateDisplay() {
    return this.dateStart + " upto today";
  }

  onRefresh() {
    this.onFilterByTime("Today");
  }

  isShowNoCheckbox = false;

  onClickCheckbox(elem?: string) {
    this.isShowNoCheckbox = false;
    if (elem === "showAll" && !this.checkbox.showAll) {
      for (let item in this.checkbox) {
        //@ts-ignore
        this.checkbox[item] = false;
      }
    } else if (elem === "showAll" && this.checkbox.showAll) {
      for (let item in this.checkbox) {
        //@ts-ignore
        this.checkbox[item] = true;
      }
    } else {
      for (let item in this.checkbox) {
        //@ts-ignore
        if (!this.checkbox[item] && elem !== "showAll") {
          this.checkbox.showAll = false;
        }
      }
    }
    if (
      !(
        this.checkbox.addToCart ||
        this.checkbox.checkout ||
        this.checkbox.conversionRate ||
        this.checkbox.purchase ||
        this.checkbox.revenue ||
        this.checkbox.umtContent ||
        this.checkbox.utmCampaign ||
        this.checkbox.utmMedium ||
        this.checkbox.utmSource ||
        this.checkbox.view ||
        this.checkbox.goCheckout
      )
    ) {
      this.isShowNoCheckbox = true;
    }
  }

  @Watch("tab")
  changedTab(value: number) {
    if (value === 0) {
      this.onFilterByTime("Today");
    }
  }

  // @Watch("timeActive")
  // changedTimeActive(value: string) {
  //   if (value && this.tab === 0) {
  //     this.onGetListStatsUtm();
  //   }
  // }
}
</script>

<style lang="scss">
.label-menu {
  .v-label.theme--light {
    color: #1f2937 !important;
    font-size: 14px;
    font-weight: 400;
  }
}
</style>
